com.io7m.r2.core.shaders.provided

## Class R2DepthShaderBasicParameters

- java.lang.Object
- - com.io7m.r2.core.shaders.provided.R2DepthShaderBasicParameters

- All Implemented Interfaces:
    R2DepthShaderBasicParametersType, R2DepthShaderBasicParametersValuesType

      @Generated(value={"Immutables.generator","R2DepthShaderBasicParametersType"})
      public final class R2DepthShaderBasicParameters
      extends Object
      implements R2DepthShaderBasicParametersType

  The type of parameters for the basic depth shader.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2DepthShaderBasicParameters.Builder` Builds instances of type `R2DepthShaderBasicParameters`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2Texture2DUsableType` | `albedoTexture()` An albedo map which is used primarily used to determine the opacity of the shaded surface.
    `float` | `alphaDiscardThreshold()` The threshold value that defines whether or not the surface fragment will be discarded.
    `static R2DepthShaderBasicParameters.Builder` | `builder()` Creates a builder for `R2DepthShaderBasicParameters`.
    `static R2DepthShaderBasicParameters` | `copyOf(R2DepthShaderBasicParametersType instance)` Creates an immutable copy of a `R2DepthShaderBasicParametersType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2DepthShaderBasicParameters` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `textureDefaults`, `albedoTexture`, `alphaDiscardThreshold`.
    `static R2DepthShaderBasicParameters` | `of(R2TextureDefaultsType textureDefaults, R2Texture2DUsableType albedoTexture, float alphaDiscardThreshold)` Construct a new immutable `R2DepthShaderBasicParameters` instance.
    `R2TextureDefaultsType` | `textureDefaults()`
    `String` | `toString()` Prints the immutable value `R2DepthShaderBasicParameters` with attribute values.
    `R2DepthShaderBasicParameters` | `withAlbedoTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `albedoTexture` attribute.
    `R2DepthShaderBasicParameters` | `withAlphaDiscardThreshold(float value)` Copy the current immutable object by setting a value for the `alphaDiscardThreshold` attribute.
    `R2DepthShaderBasicParameters` | `withTextureDefaults(R2TextureDefaultsType value)` Copy the current immutable object by setting a value for the `textureDefaults` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### textureDefaults

          public R2TextureDefaultsType textureDefaults()

      Specified by:
        `textureDefaults` in interface `R2DepthShaderBasicParametersType`
      Specified by:
        `textureDefaults` in interface `R2DepthShaderBasicParametersValuesType`
      Returns:
        The value of the `textureDefaults` attribute

    - #### albedoTexture

          public R2Texture2DUsableType albedoTexture()

      Description copied from interface: `R2DepthShaderBasicParametersValuesType`

      An albedo map which is used primarily used to determine the opacity of the shaded surface.

      Specified by:
        `albedoTexture` in interface `R2DepthShaderBasicParametersType`
      Specified by:
        `albedoTexture` in interface `R2DepthShaderBasicParametersValuesType`
      Returns:
        The value of the `albedoTexture` attribute

    - #### alphaDiscardThreshold

          public float alphaDiscardThreshold()

      Description copied from interface: `R2DepthShaderBasicParametersValuesType`
      The threshold value that defines whether or not the surface fragment will be discarded. If the opacity of the surface is less than this threshold value, the surface will be discarded. A threshold value of `0.0` will result in no fragments ever being discarded.
      Specified by:
        `alphaDiscardThreshold` in interface `R2DepthShaderBasicParametersType`
      Specified by:
        `alphaDiscardThreshold` in interface `R2DepthShaderBasicParametersValuesType`
      Returns:
        The value of the `alphaDiscardThreshold` attribute

    - #### withTextureDefaults

          public final R2DepthShaderBasicParameters withTextureDefaults(R2TextureDefaultsType value)

      Copy the current immutable object by setting a value for the `textureDefaults` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for textureDefaults
      Returns:
        A modified copy of the `this` object

    - #### withAlbedoTexture

          public final R2DepthShaderBasicParameters withAlbedoTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `albedoTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for albedoTexture
      Returns:
        A modified copy of the `this` object

    - #### withAlphaDiscardThreshold

          public final R2DepthShaderBasicParameters withAlphaDiscardThreshold(float value)

      Copy the current immutable object by setting a value for the `alphaDiscardThreshold` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for alphaDiscardThreshold
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2DepthShaderBasicParameters` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `textureDefaults`, `albedoTexture`, `alphaDiscardThreshold`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2DepthShaderBasicParameters` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2DepthShaderBasicParameters of(R2TextureDefaultsType textureDefaults,
                                                        R2Texture2DUsableType albedoTexture,
                                                        float alphaDiscardThreshold)

      Construct a new immutable `R2DepthShaderBasicParameters` instance.
      Parameters:
        `textureDefaults` - The value for the `textureDefaults` attribute
        `albedoTexture` - The value for the `albedoTexture` attribute
        `alphaDiscardThreshold` - The value for the `alphaDiscardThreshold` attribute
      Returns:
        An immutable R2DepthShaderBasicParameters instance

    - #### copyOf

          public static R2DepthShaderBasicParameters copyOf(R2DepthShaderBasicParametersType instance)

      Creates an immutable copy of a `R2DepthShaderBasicParametersType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2DepthShaderBasicParameters instance

    - #### builder

          public static R2DepthShaderBasicParameters.Builder builder()

      Creates a builder for `R2DepthShaderBasicParameters`.
      Returns:
        A new R2DepthShaderBasicParameters builder

Copyright © 2016 <code@io7m.com> http://io7m.com